#property copyright ". +Index.mq4 6.1.  2008-2012 Plus."
#property link      "http://fxcoder.ru"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 LimeGreen
#property indicator_width1 1

//   
extern string Index = "USD";

//  (1/x)
extern bool Reverse = false;

//  ,    
//  1: AUD,CAD,CHF,EUR,GBP,JPY,NZD,USD
//  2: SGD,DKK,MXN,NOK,SEK,ZAR
//  3: usd,#aa,#aapl,#amzn,#axp,#ba,#bac,#cat,#csco,#cvx,#dd,#dis,#ebay,#ek,#fcx,#fdx
extern string CalcCurrs = "AUD,CAD,CHF,EUR,GBP,JPY,NZD,USD";

//    
extern int AppliedPrice = PRICE_CLOSE;

//  ,   
extern int MAPeriod = 0;

// ,     
extern int DiffMAPeriod = 0;

//  ,   
extern int MAMethod = MODE_SMA;

//      100 (      )
extern bool LogScale = false;

//      (      )
string BaseCurr = "USD";

//  
double I[];

//  
string syms[];
int dirs[];
bool indexInitialized = false;
int crossCount;

int start()
{
	// ,     
	if (!indexInitialized)
		return(0);

	//   
	int counted_bars = IndicatorCounted();
	if (counted_bars > 0)
		counted_bars--;
	int barsCount = Bars - counted_bars;
	//barsCount = MathMin(barsCount, 100);

	for (int i = barsCount - 1; i >= 0; i--)
	{
		//  
		double value = Index(syms, dirs, crossCount, AppliedPrice, MAPeriod, MAMethod, i);

		if (DiffMAPeriod > 0 && value > 0)
		{
			double diffMA = Index(syms, dirs, crossCount, AppliedPrice, DiffMAPeriod, MAMethod, i);
			if (diffMA > 0)
				value /= diffMA;
			else
				value = 0;
		}

		//    
		if (value > 0)
		{
			if (Reverse)
			{
				if (LogScale)
					I[i] = - MathLog(value) * 100.0;
				else
					I[i] = 1.0 / value;
			}
			else
			{
				if (LogScale)
					I[i] = MathLog(value) * 100.0;
				else
					I[i] = value;
			}
		}
		else
		{
			I[i] = EMPTY_VALUE;
		}
	}

	return(0);
}

int init()
{
	//  
	CalcCurrs = UpperString(CalcCurrs);
	Index = UpperString(Index);
	MAMethod = IntPutInRange(MAMethod, 0, 3);

	//   ,       ( , 6 )
	if (StringLen(Symbol()) == 6)
	{
		if (Index == "1")
			Index = StringSubstr(Symbol(), 0, 3);
		else if (Index == "2")
			Index = StringSubstr(Symbol(), 3, 3);
	}

	//   (  )
	indexInitialized = IndexInit(Index, BaseCurr, CalcCurrs, syms, dirs, crossCount);

	string name =
		WindowExpertName() + ": " +
		Ifs(LogScale, "100*ln(") +
		Ifs(Reverse, "1/(") +

		Ifs(MAPeriod > 0,
			MAMethodToString(MAMethod) + MAPeriod + "(" + Index + ")",
			Index
			) +

		Ifs(DiffMAPeriod > 0,
			"/" + MAMethodToString(MAMethod) + DiffMAPeriod + "(" + Index + ")") +

		Ifs(Reverse, ")") +
		Ifs(LogScale, ")") +
		"," + AppliedPriceToString(AppliedPrice)
		;

	SetIndexLabel(0, name);
	IndicatorShortName(StringSubstr(name, 0, 63));
	SetIndexStyle(0, DRAW_LINE);
	SetIndexBuffer(0, I);

	return(0);
}

string TrimLeft(string s, int ch = 0)
{
	if (ch == 0)
	{
		s = StringTrimLeft(s);
	}
	else
	{
		int len = StringLen(s);

		// 
		int cut = 0;

		for (int i = 0; i < len; i++)
		{
			if (StringGetChar(s, i) == ch)
				cut++;
			else
				break;
		}

		if (cut > 0)
		{
			if (cut > len - 1)
				s = "";
			else
				s = StringSubstr(s, cut);
		}
	}
	return(s);
}

string TrimRight(string s, int ch = 0)
{
	if (ch == 0)
	{
		s = StringTrimRight(s);
	}
	else
	{
		int len = StringLen(s);

		// 
		int cut = len;

		for (int i = len - 1; i >= 0; i--)
		{
			if (StringGetChar(s, i) == ch)
				cut--;
			else
				break;
		}

		if (cut != len)
		{
			if (cut == 0)
				s = "";
			else
				s = StringSubstr(s, 0, cut);
		}
	}
	return(s);
}

string Trim(string s, int ch = 0)
{
	if (ch == 0)
		return(StringTrimLeft(StringTrimRight(s)));
	else
		return(TrimLeft(TrimRight(s, ch), ch));
}

int SplitString(string s, string sep, string& parts[], bool removeEmpty = false)
{
	int count = 0;
	int sepLen = StringLen(sep);

	string part;
	while (true)
	{
		int p = StringFind(s, sep);
		if (p >= 0)
		{
			if (p == 0)
				part = "";
			else
				part = StringSubstr(s, 0, p);

			if (!removeEmpty || (Trim(part) != ""))
			{
				count++;
				ArrayResize(parts, count);
				parts[count - 1] = part;
			}

			s = StringSubstr(s, p + sepLen);
		}
		else
		{
			//  
			if (!removeEmpty || (Trim(s) != ""))
			{
				count++;
				ArrayResize(parts, count);
				parts[count - 1] = s;
			}

			break;
		}
	}

	//    
	if ((count > 0) && (parts[count - 1] == ""))
	{
		count--;
		ArrayResize(parts, count);
	}

	return(count);
}

string UpperString(string s)
{
	int c = StringLen(s);
	int ch;

	for (int i = 0; i < c; i++)
	{
		// Upper char
		ch = StringGetChar(s, i);

		if ((ch > 96 && ch < 123) || (ch > 223 && ch < 256))
			ch -= 32;

		s = StringSetChar(s, i, ch);
	}

	return(s);
}

string AppliedPriceToString(int ap, bool verbose = false)
{
	if (verbose)
	{
		switch (ap)
		{
			case 0: return("Close");
			case 1: return("Open");
			case 2: return("High");
			case 3: return("Low");
			case 4: return("Median");
			case 5: return("Typical");
			case 6: return("Weighted");
			default: return("Unknown");
		}
	}
	else
	{
		switch (ap)
		{
			case 0: return("C");
			case 1: return("O");
			case 2: return("H");
			case 3: return("L");
			case 4: return("HL");
			case 5: return("HLC");
			case 6: return("HLCC");
			default: return("?");
		}
	}
}

string MAMethodToString(int mm)
{
	switch (mm)
	{
		case MODE_SMA: return("SMA");
		case MODE_EMA: return("EMA");
		case MODE_SMMA: return("SMMA");
		case MODE_LWMA: return("LWMA");
		default: return("MA(type " + mm +")");
	}
}

string Ifs(bool c, string s1, string s2 = "")
{
	if (c)
		return(s1);
	else
		return(s2);
}

int IntPutInRange(int value, int from, int to)
{
	if (to >= from)
	{
		if (value > to)
			value = to;
		else if (value < from)
			value = from;
	}

	return(value);
}

/*   */

int StringArrayIndexOf(string& array[], string value, int startingFrom = 0)
{
	int index = - 1;
	int count = ArraySize(array);

	for (int i = startingFrom; i < count; i++)
	{
		if (array[i] == value)
		{
			index = i;
			break;
		}
	}

	return(index);
}

int StringArrayAdd(string& arr[], string value)
{
	int c = ArraySize(arr);
	ArrayResize(arr, c + 1);
	arr[c] = value;
	return(c);
}

int IntArrayAdd(int& arr[], int value)
{
	int c = ArraySize(arr);
	ArrayResize(arr, c + 1);
	arr[c] = value;
	return(c);
}

//  
double MA(string symbol, int timeframe, int ap, int maPeriod, int maMethod, int bar)
{
	//    
	if (symbol != Symbol())
		bar = iBarShift(symbol, timeframe, Time[bar]);

	if (maPeriod > 0)
		return(iMA(symbol, timeframe, maPeriod, 0, maMethod, ap, bar));

	//   < 2,  
	double o, h, l, c;
	double p = 0;

	switch(ap)
	{
		case 0:
			p = iClose(symbol, timeframe, bar);
			break;

		case 1:
			p = iOpen(symbol, timeframe, bar);
			break;

		case 2:
			p = iHigh(symbol, timeframe, bar);
			break;

		case 3:
			p = iLow(symbol, timeframe, bar);
			break;

		case 4:
			h = iHigh(symbol, timeframe, bar);
			l = iLow(symbol, timeframe, bar);
			if (h != 0 && l != 0)
				p = (h + l) / 2.0;
			break;

		case 5:
			h = iHigh(symbol, timeframe, bar);
			l = iLow(symbol, timeframe, bar);
			c = iClose(symbol, timeframe, bar);
			if (h != 0 && l != 0 && c != 0)
				p = (h + l + c) / 3.0;
			break;

		case 6:
			h = iHigh(symbol, timeframe, bar);
			l = iLow(symbol, timeframe, bar);
			c = iClose(symbol, timeframe, bar);
			if (h != 0 && l != 0 && c != 0)
				p = (h + l + 2.0 * c) / 4.0;
			break;
	}

	return(p);
}

//   (  )
bool IndexInit(string index, string baseCurr, string calcCurrs, string& syms[], int& dirs[], int& crossCount)
{
	ArrayResize(syms, 0);
	ArrayResize(dirs, 0);

	string currs[];
	crossCount = SplitString(calcCurrs, ",", currs, true);
	if (StringArrayIndexOf(currs, index) == -1)
		crossCount++;

	bool ok = crossCount > 0;
	ok = ok && index__getSymbols(index, baseCurr, currs, syms, dirs);

	return(ok);
}

//     ,  maPeriod=0  
// (     ,   )
double Index(string& syms[], int& dirs[], int crossCount, int ap, int maPeriod, int maMethod, int bar)
{
	int c = 0;
	double value, q;

	//   
	value = 1.0;

	int sc = ArraySize(syms);

	for (int j = 0; j < sc; j++)
	{
		q = MA(syms[j], 0, ap, maPeriod, maMethod, bar);

		if (q > 0 && q != EMPTY_VALUE)
		{
			value *= MathPow(q, 1.0 * dirs[j] / crossCount);
			c++;
		}
		else
		{
			value = 0;
			break;
		}
	}

	if (value == 0 || sc == 0)
		value = 0.0;

	return(value);
}

//           
bool index__getSymbols(string index, string baseCurr, string& currs[], string& syms[], int& dirs[])
{
	bool ok = true;

	//    
	int cc = ArraySize(currs);

	for (int i = 0; i < cc; i++)
	{
		string curr2 = currs[i];
		if (index != curr2)
		{
			if (index == baseCurr)
				index__addSymbol(baseCurr, curr2, syms, dirs);
			else if (curr2 == baseCurr)
				index__addSymbol(index, baseCurr, syms, dirs);
			else
			{
				if (!(index__addSymbol(index, baseCurr, syms, dirs)
						&& index__addSymbol(baseCurr, curr2, syms, dirs)))
				{
					ok = false;
					break;
				}
			}
		}
	}

	if (ok)
	{
		ok = ok && (ArraySize(syms) != 0);
	}
	else
	{
		ArrayResize(syms, 0);
		ArrayResize(dirs, 0);
	}

	return(ok);
}

//      
//  curr1/curr2: EUR/USD, #AA/USD, USD/_SP500, USD/AUD.
bool index__addSymbol(string curr1, string curr2, string& syms[], int& dirs[])
{
	//        
	string sym = "";
	bool isCross = true;

	// CFD  
	if (curr2 == "USD" && (StringGetChar(curr1, 0) == '#' || StringGetChar(curr1, 0) == '_'))
	{
		sym = curr1;
		isCross = false;
	}
	else if (curr1 == "USD" && (StringGetChar(curr2, 0) == '#' || StringGetChar(curr2, 0) == '_'))
	{
		sym = curr2;
		isCross = false;
	}
	else
	{
		sym = curr1 + curr2;
	}

	//      
	if (MarketInfo(sym, MODE_BID) <= 0 && isCross)
	{
		sym = curr2 + curr1;
		if (MarketInfo(sym, MODE_BID) <= 0)
			sym = "";
	}

	//  
	if (sym != "")
	{
		int si = StringArrayIndexOf(syms, sym);
		if (isCross)
		{
			if (si >= 0)
			{
				//       ,    
				if (curr1 == StringSubstr(sym, 0, 3))
					dirs[si]++;
				else
					dirs[si]--;
			}
			else
			{
				//     
				StringArrayAdd(syms, sym);

				if (curr1 == StringSubstr(sym, 0, 3))
					IntArrayAdd(dirs, 1);
				else
					IntArrayAdd(dirs, -1);
			}
		}
		else
		{
			if (si >= 0)
			{
				//       ,    
				if (curr1 == sym)
					dirs[si]++;
				else
					dirs[si]--;
			}
			else
			{
				//     
				StringArrayAdd(syms, sym);

				if (curr1 == sym)
					IntArrayAdd(dirs, 1);
				else
					IntArrayAdd(dirs, -1);
			}
		}

		return(true);
	}

	return(false);
}

// 2013-09-08 19:52:30 UTC
// MQLMake 1.18. Copyright  Plus (FXcoder.ru) 2011-2012. http://fxcoder.ru